PVector polar( float r, float theta )
{
  float dt = radians( theta );
  
  float x = r * cos( dt );
  float y = r * sin( dt );
  
  return new PVector( x, y );
}

float[] pts;

void setup()
{
  size( 500, 500 );
  background( 100 );
  fill( 0 );
  ellipse( 250, 250, 400, 400 );
  
  pts = new float[20];
  for( int idx = 0; idx < 20; idx += 2 ) {
    pts[idx] = random( 30, 190 );
    pts[idx+1] = random( 360 );
  }
}

void draw()
{
  fill( 0, 20 );
  noStroke();
  ellipse( 250, 250, 400, 400 );
  
  noFill();
  stroke( 0, 200, 0, 200 );
  strokeWeight( 3 );
  
  float ang = frameCount % 360;
  
  PVector pt = polar( 198, ang );
  line( 250, 250, 250+pt.x, 250-pt.y );
  
  for( int idx = 0; idx < 20; idx += 2 ) {
    float r = pts[idx];
    float theta = pts[idx+1];
    if( abs( theta - ang  ) < 5 ) {
      PVector p = polar( r, theta );
      noFill();
      stroke( 0, 255, 0, 255 );
      strokeWeight( 2 );
      ellipse( 250 + p.x, 250 - p.y, 8, 8 );
    }
  }
}