// Craig S. Kaplan
// A simple visualization of regular polygons, drawn
// using polar coordinates.

int num_sides = 3;

PVector polar( float r, float theta )
{
  float dt = radians( theta );
  
  float x = r * cos( dt );
  float y = r * sin( dt );
  
  return new PVector( x, y );
}

void setup()
{
  size( 500, 500 );
}

void draw()
{
  background( 200 );
  
  stroke( 255 );
  strokeWeight( 2 );
  fill( 100 );
  
  beginShape();
  for( int idx = 0; idx < num_sides; ++idx ) {
    float ang = map( idx, 0, num_sides, 0, 360 );
    PVector pt = polar( 200, ang );
    vertex( width/2 + pt.x, width/2 + pt.y );
  }
  endShape( CLOSE );
}

void keyPressed()
{
  if( keyCode == UP ) {
    ++num_sides;
  } else {
    num_sides = max( 3, num_sides - 1 );
  }
}