// Craig S. Kaplan
// A demonstration of using beginShape()/vertex()/endShape()
// to draw a graph.  In this case, we plot the amount of 
// arctic sea ice in January of each year from 1979 to 2016.
// Note that the graph is generally going down.

void setup()
{
  size( 800, 400 );

  float[] samps = float( loadStrings( "january.txt" ) );
  
  // I used these lines to determine the range of the
  // graph, in order to plan how much to stretch y values
  // below.
  
  //println( max( samps ) ); // -- 15.6
  //println( min( samps ) ); // -- 13.64

  background( 80 );
  stroke( 255 );
  strokeWeight( 2 );
  noFill();

  beginShape();
  for ( int idx = 0; idx < samps.length; ++idx ) {
    vertex(
      map( idx, 0, samps.length-1, 0, width ), 
      map( samps[idx], 13, 17, height, 0 ) );
  }
  endShape();

  for ( int idx = 0; idx < 21; ++idx ) {
    float y = map( idx, 0, 20, height, 0 );

    strokeWeight( 1.0 );
    noFill();
    line( 0, y, 10, y );
    
    fill( 255 );
    text( "" + map( idx, 0, 20, 13, 17 ), 12, y );
  }
}