// Craig S. Kaplan
// A very simple demonstration of polar coordinates: a point moving
// in a circle.

PVector polar( float r, float theta )
{
  float dt = radians( theta );
  
  float x = r * cos( dt );
  float y = r * sin( dt );
  
  return new PVector( x, y );
}

void setup()
{
  size( 500, 500 );
  background( 0 );
}

void draw()
{
  float ang = -frameCount;
  
  // Use some pretty blur effects just for eye candy.
  filter( BLUR, 1 );
  fill( 255 );
  noStroke();
  
  PVector P = polar( 200, ang );
  ellipse( width/2 + P.x, height/2 + P.y, 30, 30 );
}