// Craig S. Kaplan
// A fun visualization of lots of fancy
// spirals, including the generalization to
// pretty geometric patterns.

PVector polar( float r, float theta )
{
  float dt = radians( theta );
  
  float x = r * cos( dt );
  float y = r * sin( dt );
  
  return new PVector( x, y );
}

void setup()
{
  size( 500, 500 );
}

void draw()
{
  background( 50 );
  
  stroke( 255 );
  strokeWeight( 2 );
  noFill();
  
  beginShape();
  
  float theta_mult = map( mouseX, 0, width, 0.5, 180 );
  float r_inc = map( mouseY, 0, height, 0.01, 1.0 );
  
  for( int idx = 0;; ++idx ) {
    float theta = idx * theta_mult;
    float r = theta * r_inc;
    
    if( r > 300 ) {
      break;
    }
    
    PVector pt = polar( r, theta );
    vertex( width/2 + pt.x, width/2 + pt.y );
  }
  endShape();
}